## msxpertsuite 5.1.1

=== debian/changelog ===
msxpertsuite (5.1.1-1) unstable; urgency=low

  * New upstream release.

  * Fix bug with the failing mass spectrometric data file slicer.

  * Fix bug with the deconvolution of the isotopic cluster.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 24 May 2018 18:40:18 +0200
