=== debian/control ===
Source: msxpertsuite
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper (>=9.20130630),
               dpkg-dev (>= 1.16.1~),
               graphicsmagick-imagemagick-compat,
               libgomp1,
               rubber (>= 1.4),
               qtbase5-dev (>= 5.7.0),
               libqt5svg5-dev (>= 5.7.0),
               qtscript5-dev (>= 5.7.0),
               cmake (>= 3.2.2-2),
               texlive-latex-recommended,
               biber,
               latex2html,
               texlive-fonts-recommended,
							 texlive-lang-french,
							 texlive-lang-cyrillic,
               libqcustomplot-dev(>= 1.3.2),
               libpwiz-dev(>=3.0.10827),
               libboost-dev (>= 1.56.0),
               docbook-to-man,
               libtclap-dev,
               gsfonts,
               doxygen,
               graphviz,
               qttools5-dev-tools,
               qtchooser
Standards-Version: 4.1.3
Homepage: https://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/msxpertsuite.git
Vcs-Git: https://salsa.debian.org/debichem-team/msxpertsuite.git

Package: massxpert
Depends: msxpertsuite, ${misc:Depends}
Architecture: all
Section: oldlibs
Priority: optional
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: msxpertsuite
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         msxpertsuite-data (>= ${source:Upstream-Version}),
         msxpertsuite-data (<< ${source:Upstream-Version}A~)
Replaces: massxpert (<< 3.6.2)
Breaks: massxpert (<< 3.6.2)
Conflicts: massxpert (<< 3.6.2)
Suggests: msxpertsuite-doc
Description: mass spectrometry software suite - executable files
 msXpertSuite is a collection of programs to simulate and analyse mass
 spectrometric data obtained on linear (bio-)polymers. It is the
 successor of GNU polyXmass, first, and of massXpert, second.
 .
 Three programs, massXpert, mineXpert and convXpert allow the following:
 .
 massXpert:
  - making brand new polymer chemistry definitions;
  - using the definitions to perform easy calculations in a desktop
    calculator-like manner;
  - performing sophisticated polymer sequence editing and simulations;
  - perform m/z list comparisons;
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches, calculation of the isotopic
 pattern...
 .
 mineXpert:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Calculate and display the TIC chromatogram;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the data from the TIC chromatogram or color map
    - to mass spectrum;
    - to drift spectrum;
    - back to TIC chromatogram (XIC chromatogram);
    - reverse operations;
  - Export the data to text files;
  - Slice a big initial file into smaller chunks for easier mining;
  - Define how mining activity is recorded on disk for later use;
  - Convert mzML files into a private (albeit open) mass spectrometry
    format that allows better performance (based on SQLite3).
 .
 This package contains the binary programs.

Package: massxpert-data
Depends: msxpertsuite-data, ${misc:Depends}
Architecture: all
Section: oldlibs
Priority: optional
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: msxpertsuite-data
Architecture: all
Depends: ${misc:Depends}
Replaces: massxpert-data (<< 3.6.2)
Breaks: massxpert-data (<< 3.6.2)
Conflicts: massxpert-data (<< 3.6.2)
Description: mass spectrometry software suite - arch-indep data
 msXpertSuite is a collection of programs to simulate and analyse mass
 spectrometric data obtained on linear (bio-)polymers. It is the
 successor of GNU polyXmass, first, and of massXpert, second.
 .
 This package contains the architecture-independent data required for
 the proper functioning of msxpertsuite. For example, polymer chemistry
 definition files are in this package, for use with the massxpert program.

Package: massxpert-doc
Depends: msxpertsuite-doc, ${misc:Depends}
Architecture: all
Section: oldlibs
Priority: optional
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: msxpertsuite-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: massxpert-doc (<< 3.6.2)
Breaks: massxpert-doc (<< 3.6.2)
Conflicts: massxpert-doc (<< 3.6.2)
Description: mass spectrometry software suite - manuals
 msXpertSuite is a collection of programs to simulate and analyse mass
 spectrometric data obtained on linear (bio-)polymers. It is the
 successor of GNU polyXmass, first, and of massXpert, second.
 .
 This package contains the manuals in PDF format.

Package: msxpertsuite-dev-doc
Section: doc
Architecture: all
Depends: libjs-jquery, ${misc:Depends}
Conflicts: msxpertsuite-devdoc
Replaces: msxpertsuite-devdoc
Description: mass spectrometry software suite - developer doc
 msXpertSuite is a collection of programs to simulate and analyse mass
 spectrometric data obtained on linear (bio-)polymers. It is the
 successor of GNU polyXmass, first, and of massXpert, second.
 .
 This package contains the developer doxygen-based doc.
