=== debian/changelog ===
msxpertsuite (5.2.0-1) unstable; urgency=low

  * New upstream release.

  * Fix bug with the mzML to SQLite3 db conversion due to not allocation
    QCoreApplication before running the console-based conversion (MS Windows
    only bug, apparently).

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 25 May 2018 12:50:59 +0200
