## msxpertsuite 5.2.1

=== debian/changelog ===
msxpertsuite (5.2.1-1) unstable; urgency=low

  * New upstream release.

  * Fix integration help string that had bad keyboard key information to
    integrate to XIC chromatogram.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 29 May 2018 14:41:25 +0200
