## msxpertsuite 5.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 # Basic information about project
 
 project(msXpertSuite)
-set(VERSION 5.2.0)
+set(VERSION 5.3.0)
 
 
 # Set additional project information
