=== debian/changelog ===
msxpertsuite (5.3.0-1) unstable; urgency=low

  * New upstream release.

  * Ensure that the QScript JavaScript environment works flawlessly even in
    the context of QThread-based code. Written JS-specific functions for
    where QThread would be a problem.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 31 May 2018 14:10:03 +0200
