## msxpertsuite 5.3.2

=== debian/changelog ===
msxpertsuite (5.3.2-1) unstable; urgency=low

  * New upstream release.

  * General revision of the JavaScript reference documentation. Fixes and
    additions.

  * Small fixes.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 04 Jun 2018 22:33:37 +0200

msxpertsuite (5.3.1-1) unstable; urgency=low

  * New upstream release.

  * Make sure it is possible to record [start-end] ranges for TIC intensity
    computations in the TIC chromatogram and drift spectrum widgets.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 01 Jun 2018 16:32:11 +0200
