## msxpertsuite 5.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,8 +13,14 @@
 # youcompleteme (vim plugin).
 set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
 
-# We want C++14
-ADD_DEFINITIONS(-std=c++14 -Wno-unknown-pragmas)
+# We want C++11
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
+# deprecated, cmake does the job: ADD_DEFINITIONS(-std=c++11)
+
+# We do not want warnings for unknown pragmas:
+ADD_DEFINITIONS(-Wno-unknown-pragmas)
 
 # Include the various colors we want to use in the output
 include(outputColors)
@@ -28,7 +34,7 @@
 # Basic information about project
 
 project(msXpertSuite)
-set(VERSION 5.3.0)
+set(VERSION 5.3.3)
 
 
 # Set additional project information
