=== minexpert/CMakeLists.txt ===
# Get the name of the current directory but with no path:
#get_filename_component(TARGET ${CMAKE_CURRENT_BINARY_DIR} NAME)

# ${TARGET}-objlib will be the name of the object files collection (in CMake
# parlance that is an "OBJECT" library type. In that library, that is simply a
# list of compiled object files, I put all the *.o files that make the ${TARGET}
# (minexpert or massxpert) executable image file, but not main.cpp. This is done
# because when building the tests/tests binary for tests relating to ${TARGET},
# I'll reuse these compiled object files.

if(APPLE)
	set(TARGET mineXpert)
	message(STATUS "APPLE: ${TARGET}")
elseif(UNIX AND NOT APPLE)
	set(TARGET minexpert)
	message(STATUS "NON-APPLE: ${TARGET}")
elseif(WIN64)
	set(TARGET mineXpert.exe)
	message(STATUS "WIN64: ${TARGET}")
endif()

set(TITLE_TARGET "mineXpert")
set(DOCTARGET "minexpert")
set(MINEXPERT_TARGET ${TARGET})

# Prepare the name the target module so that we can query it
# from the parent directory.
set_directory_properties(PROPERTIES MINEXPERT_TARGET ${MINEXPERT_TARGET})

message("")
message(STATUS "${BoldGreen}Starting configuring of the ${TARGET} submodule${ColourReset}")
message("")


#############################################################
# Software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

########################################################
# Files
file(GLOB ${TARGET}-objlib_nongui_SRCS nongui/*.cpp)
file(GLOB ${TARGET}-objlib_gui_SRCS gui/*.cpp)
file(GLOB ${TARGET}-objlib_UIS gui/ui/*.ui)

# The only file that does not enter in the object library of
# object files (see notice above).
file(GLOB ${TARGET}-exec_SRCS main.cpp)

# The desktop file
if(UNIX AND NOT APPLE)
	install(FILES ${TARGET}.desktop
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
endif()

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script PrintSupport)

qt5_wrap_ui(${TARGET}-objlib_UIS_H ${${TARGET}-objlib_UIS})

qt5_add_resources(${TARGET}_QRC_CPP gui/application.qrc)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
set_source_files_properties(${${TARGET}-objlib_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
set_source_files_properties(${${TARGET}_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)


add_library(${TARGET}-objlib OBJECT
	${${TARGET}-objlib_nongui_SRCS}
	${${TARGET}-objlib_gui_SRCS}
	${${TARGET}-objlib_UIS_H})

###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(NOT APPLE)

	add_executable(${TARGET}
		${${TARGET}-exec_SRCS}
		$<TARGET_OBJECTS:${TARGET}-objlib>
		${${TARGET}_QRC_CPP})

else()

	# Copy the icon file to the Contents/Resources directory of the bundle at
	# location ${MACOSX_PACKAGE_LOCATION}.
	set_source_files_properties(../images/msXpertSuite.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	# Identify MacOS bundle

	set(MACOSX_BUNDLE_BUNDLE_NAME ${TARGET})
	message(STATUS "MACOSX_BUNDLE_BUNDLE_NAME: ${MACOSX_BUNDLE_BUNDLE_NAME}")

	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
	set(MACOSX_BUNDLE_ICON_FILE ../images/msXpertSuite.icns)

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.9"
		CACHE STRING "Flags used by the compiler during all build types." FORCE)

	#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden"
	#CACHE STRING "Flags used by the compiler during all build types." FORCE)

	set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.12.sdk/"
		CACHE STRING "MacOSX10.12.sdk." FORCE)

	add_executable(${TARGET} MACOSX_BUNDLE
		${${TARGET}-exec_SRCS}
		$<TARGET_OBJECTS:${TARGET}-objlib>
		${${TARGET}_QRC_CPP}
		../images/msXpertSuite.icns
		)

	set_target_properties(${TARGET} PROPERTIES MACOSX_BUNDLE_ICON_FILE msXpertSuite.icns)

endif()


###############################################################
# Installation directories depending on the platform and module
###############################################################

if(WIN64)

	set(CMAKE_INSTALL_PREFIX "C:/Program Files/msXpertSuite")

	message(STATUS "${BoldYellow}Detected WIN64. Install prefix set to ${CMAKE_INSTALL_PREFIX}${ColourReset}")

	set(MSXPERTSUITE_BIN_DIR ${CMAKE_INSTALL_PREFIX})
	set(MSXPERTSUITE_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data/${TARGET})
	set(MSXPERTSUITE_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc)

elseif(UNIX AND NOT APPLE)

	message(STATUS "${BoldYellow}Detected UNIX NOT APPLE.${ColourReset}")
	#set(CMAKE_INSTALL_PREFIX "/usr/local")
	set(MSXPERTSUITE_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
	set(MSXPERTSUITE_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite/${TARGET})
	set(MSXPERTSUITE_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/msxpertsuite)

elseif(APPLE)
	message(STATUS "${BoldYellow}Detected APPLE.${ColourReset}")

	# At this point, we need to make sure we configure the install directories
	# specifically for APPLE:

	set(BUNDLE_DIR ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.app)
	set(CMAKE_INSTALL_PREFIX "${BUNDLE_DIR}/Contents")
	set(MSXPERTSUITE_BIN_DIR ${BUNDLE_DIR}/Contents/MacOS)
	set(MSXPERTSUITE_DATA_DIR ${BUNDLE_DIR}/Contents/Resources/data)
	set(MSXPERTSUITE_DOC_DIR ${BUNDLE_DIR}/Contents/doc)

endif()

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "MSXPERTSUITE_BIN_DIR: ${MSXPERTSUITE_BIN_DIR}")
message(STATUS "MSXPERTSUITE_DATA_DIR: ${MSXPERTSUITE_DATA_DIR}")
message(STATUS "MSXPERTSUITE_DOC_DIR: ${MSXPERTSUITE_DOC_DIR}")

# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/config.h.in
	${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(

	# The config file is binary directory-specific !!!
	# For the config.h file generated from config.h.in
	# For the ui_Xyyyyy.h files
	${CMAKE_CURRENT_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_BINARY_DIR}/libmassgui

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS})


# On GNU/Linux, make sure we have the QCustomPlot library
# installed on the system (on MINGW, we have the
# source files (see above).
if(NOT WIN64 AND NOT APPLE)

	find_package(QCustomPlot)

	if(NOT QCustomPlot_FOUND)
		message(FATAL_ERROR "QCustomPlot not found!")
	else()
		message(STATUS "QCustomPlot found!")
	endif()

endif()

# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
if(APPLE)

	set(MASSLIB "${CMAKE_BINARY_DIR}/libmass/libmass.a")
	set(MASSGUILIB "${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

else()

	set(MASSLIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive")
	set(MASSGUILIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive")

endif()

message(STATUS "libdir: ${CMAKE_BINARY_DIR}/libmass/libmass.a")
message(STATUS "guilibdir: ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport)


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(WIN64)
	include_directories("/mingw64/include/pwiz")
elseif(APPLE)
	include_directories("/opt/local/include/pwiz")
	link_directories("/opt/local/lib")
else()
	include_directories("/usr/include/pwiz")
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)

##############################################################
# libboost_* on mingw
# On MINGW.* we are our own provider of the boost libraries.
if(WIN64)

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	include_directories("${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)

elseif(APPLE)
	# With macport
	include_directories("/opt/local/include")
	# Attention #####
	# below for
	# /opt/local/include/pwiz/libraries/boost_aux/boost/utility/singleton.hpp
	include_directories("/opt/local/include/pwiz/libraries/boost_aux")
	link_directories("/opt/local/lib")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono-mt
		boost_filesystem-mt
		boost_iostreams-mt
		boost_program_options-mt
		boost_serialization-mt
		boost_system-mt
		boost_thread-mt
		z)

endif()

# On MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(WIN64)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")

endif()

# When on UNIX/NOT APPLE we can make use the system-wide qcustomplot library.
if(UNIX AND NOT APPLE)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"qcustomplot")

endif()


#### Debugging stuff
message(STATUS required_target_link_libraries: ${required_target_link_libraries})

message(STATUS "Now printing all the include directories -I...")

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
foreach(dir ${dirs})
	message(STATUS "included dir='${dir}'")
endforeach()

message(STATUS "Now printing all the linking directories -L...")

get_property(dirs DIRECTORY PROPERTY LINK_DIRECTORIES)
foreach(dir ${dirs})
	message(STATUS "link directory dir='${dir}'")
endforeach()

# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
	${required_target_link_libraries})


# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)

if(PROFILE)
	message(STATUS "Profiling is requested, adding linker -pg flag.")
	set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

if(NOT APPLE)
	# We want to install the binary arch-dependent target in
	# specific situations. To have proper control, we define the arch
	# component.
	install(TARGETS ${TARGET}
		RUNTIME
		COMPONENT arch
		DESTINATION ${MSXPERTSUITE_BIN_DIR})
endif()


#############################################################
##########################
# EXTRACTION OF THE JAVASCRIPT-RELATED DOCUMENTATION FROM THE SOURCE FILES

if(UNIX AND NOT APPLE)
	if(DEVMODE)

		message(STATUS "${TITLE_TARGET} extracting JavaScript-related documentation")
		execute_process(COMMAND devdoc/scripts/jsExtract.py -i libmass/DataPointJs.cpp
			libmass/DataPointJsPrototype.cpp
			minexpert/nongui/SavGolParamsJSDoc.cpp
			minexpert/nongui/SavGolFilterJs.cpp minexpert/nongui/SavGolFilterJsPrototype.cpp
			minexpert/nongui/MzIntegrationParamsJs.cpp minexpert/nongui/MzIntegrationParamsJsPrototype.cpp
			libmass/TraceJs.cpp libmass/TraceJsPrototype.cpp
			libmass/MassSpectrumJs.cpp libmass/MassSpectrumJsPrototype.cpp
			minexpert/gui/AbstractPlotWidget.cpp minexpert/gui/ColorMapPlotWidget.cpp
			minexpert/gui/TicChromPlotWidget.cpp minexpert/gui/MassSpecPlotWidget.cpp
