=== debian/changelog ===
msxpertsuite (5.3.3-1) unstable; urgency=low

  * New upstream release.

  * Fix the "ignore error" directive in the user manual documentation Makefile
    that drives the LaTeX-based compilation of the documents (Closes: #901154);

  * Revert C++14 to C++11 to maintain compatibility with OSes that are less
    advanced with gcc;

  * Fix problem with loading Agilent data because of drift bin count variable.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 20 Jun 2018 17:42:48 +0200
