## msxpertsuite 5.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,7 @@
 # Basic information about project
 
 project(msXpertSuite)
-set(VERSION 5.3.3)
+set(VERSION 5.6.0)
 
 
 # Set additional project information
