=== minexpert/javascript/CMakeLists.txt ===
###############
# install stuff

INSTALL (DIRECTORY scripts
	DESTINATION ${MSXPERTSUITE_JAVASCRIPT_DIR})
