=== debian/rules ===
--- 
+++ 
@@ -68,8 +68,6 @@
 	rm -f massxpert/user-manual/massxpert-doc.pdf \
 		minexpert/user-manual/minexpert-doc.pdf
 
-# Remove all the doxygen-generated developer documentation.
-	rm -rf devdoc/html
 
 build-indep-stamp:
 	dh_testdir
@@ -89,14 +87,6 @@
 	cd $(BUILD_DIR) && $(MAKE) -j1 massxpert-user-manual
 
 	cd $(BUILD_DIR) && $(MAKE) -j1 minexpert-user-manual
-
-	# The qthelp target depends on the devdoc target
-	# that is responsible for compiling the Doxygen-based documentation
-	cd $(BUILD_DIR) && $(MAKE) qthelp
-
-	rm devdoc/html/jquery.js
-
-	find devdoc/html -name "*.md5" | xargs rm
 
 	touch build-indep-stamp
